<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<meta http-equiv="content-type" content="text/html; charset=ISO-8859-1" /><title>HttpVersion xref</title>
<link type="text/css" rel="stylesheet" href="../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../apidocs/org/apache/commons/httpclient/HttpVersion.html">View Javadoc</a></div><pre>

<a name="1" href="#1">1</a>   <em class="comment">/*</em>
<a name="2" href="#2">2</a>   <em class="comment"> * $HeadURL: https://svn.apache.org/repos/asf/httpcomponents/oac.hc3x/trunk/src/java/org/apache/commons/httpclient/HttpVersion.java $</em>
<a name="3" href="#3">3</a>   <em class="comment"> * $Revision$</em>
<a name="4" href="#4">4</a>   <em class="comment"> * $Date$</em>
<a name="5" href="#5">5</a>   <em class="comment"> *</em>
<a name="6" href="#6">6</a>   <em class="comment"> * ====================================================================</em>
<a name="7" href="#7">7</a>   <em class="comment"> *</em>
<a name="8" href="#8">8</a>   <em class="comment"> *  Licensed to the Apache Software Foundation (ASF) under one or more</em>
<a name="9" href="#9">9</a>   <em class="comment"> *  contributor license agreements.  See the NOTICE file distributed with</em>
<a name="10" href="#10">10</a>  <em class="comment"> *  this work for additional information regarding copyright ownership.</em>
<a name="11" href="#11">11</a>  <em class="comment"> *  The ASF licenses this file to You under the Apache License, Version 2.0</em>
<a name="12" href="#12">12</a>  <em class="comment"> *  (the "License"); you may not use this file except in compliance with</em>
<a name="13" href="#13">13</a>  <em class="comment"> *  the License.  You may obtain a copy of the License at</em>
<a name="14" href="#14">14</a>  <em class="comment"> *</em>
<a name="15" href="#15">15</a>  <em class="comment"> *      <a href="http://www.apache.org/licenses/LICENSE-2.0" target="alexandria_uri">http://www.apache.org/licenses/LICENSE-2.0</a></em>
<a name="16" href="#16">16</a>  <em class="comment"> *</em>
<a name="17" href="#17">17</a>  <em class="comment"> *  Unless required by applicable law or agreed to in writing, software</em>
<a name="18" href="#18">18</a>  <em class="comment"> *  distributed under the License is distributed on an "AS IS" BASIS,</em>
<a name="19" href="#19">19</a>  <em class="comment"> *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.</em>
<a name="20" href="#20">20</a>  <em class="comment"> *  See the License for the specific language governing permissions and</em>
<a name="21" href="#21">21</a>  <em class="comment"> *  limitations under the License.</em>
<a name="22" href="#22">22</a>  <em class="comment"> * ====================================================================</em>
<a name="23" href="#23">23</a>  <em class="comment"> *</em>
<a name="24" href="#24">24</a>  <em class="comment"> * This software consists of voluntary contributions made by many</em>
<a name="25" href="#25">25</a>  <em class="comment"> * individuals on behalf of the Apache Software Foundation.  For more</em>
<a name="26" href="#26">26</a>  <em class="comment"> * information on the Apache Software Foundation, please see</em>
<a name="27" href="#27">27</a>  <em class="comment"> * &lt;<a href="http://www.apache.org/" target="alexandria_uri">http://www.apache.org/</a>>.</em>
<a name="28" href="#28">28</a>  <em class="comment"> *</em>
<a name="29" href="#29">29</a>  <em class="comment"> */</em>
<a name="30" href="#30">30</a>  
<a name="31" href="#31">31</a>  <strong>package</strong> <a href="../../../../org/apache/commons/httpclient/package-summary.html">org.apache.commons.httpclient</a>;
<a name="32" href="#32">32</a>  
<a name="33" href="#33">33</a>  <em>/**<em>*</em></em>
<a name="34" href="#34">34</a>  <em> *  &lt;p>HTTP version, as specified in RFC 2616.&lt;/p></em>
<a name="35" href="#35">35</a>  <em> *  &lt;p></em>
<a name="36" href="#36">36</a>  <em> *  HTTP uses a "&amp;lt;major&amp;gt;.&amp;lt;minor&amp;gt;" numbering scheme to indicate</em>
<a name="37" href="#37">37</a>  <em> *  versions of the protocol. The protocol versioning policy is intended to</em>
<a name="38" href="#38">38</a>  <em> *  allow the sender to indicate the format of a message and its capacity for</em>
<a name="39" href="#39">39</a>  <em> *  understanding further HTTP communication, rather than the features</em>
<a name="40" href="#40">40</a>  <em> *  obtained via that communication. No change is made to the version</em>
<a name="41" href="#41">41</a>  <em> *  number for the addition of message components which do not affect</em>
<a name="42" href="#42">42</a>  <em> *  communication behavior or which only add to extensible field values.</em>
<a name="43" href="#43">43</a>  <em> *  The &amp;lt;minor&amp;gt; number is incremented when the changes made to the</em>
<a name="44" href="#44">44</a>  <em> *  protocol add features which do not change the general message parsing</em>
<a name="45" href="#45">45</a>  <em> *  algorithm, but which may add to the message semantics and imply</em>
<a name="46" href="#46">46</a>  <em> *  additional capabilities of the sender. The &amp;lt;major&amp;gt; number is</em>
<a name="47" href="#47">47</a>  <em> *  incremented when the format of a message within the protocol is</em>
<a name="48" href="#48">48</a>  <em> *  changed. See RFC 2145 [36] for a fuller explanation.</em>
<a name="49" href="#49">49</a>  <em> *  &lt;/p></em>
<a name="50" href="#50">50</a>  <em> *  &lt;p></em>
<a name="51" href="#51">51</a>  <em> *  The version of an HTTP message is indicated by an HTTP-Version field</em>
<a name="52" href="#52">52</a>  <em> *  in the first line of the message.</em>
<a name="53" href="#53">53</a>  <em> *  &lt;/p></em>
<a name="54" href="#54">54</a>  <em> *  &lt;pre></em>
<a name="55" href="#55">55</a>  <em> *     HTTP-Version   = "HTTP" "/" 1*DIGIT "." 1*DIGIT</em>
<a name="56" href="#56">56</a>  <em> *  &lt;/pre></em>
<a name="57" href="#57">57</a>  <em> *  &lt;p></em>
<a name="58" href="#58">58</a>  <em> *   Note that the major and minor numbers MUST be treated as separate</em>
<a name="59" href="#59">59</a>  <em> *   integers and that each MAY be incremented higher than a single digit.</em>
<a name="60" href="#60">60</a>  <em> *   Thus, HTTP/2.4 is a lower version than HTTP/2.13, which in turn is</em>
<a name="61" href="#61">61</a>  <em> *   lower than HTTP/12.3. Leading zeros MUST be ignored by recipients and</em>
<a name="62" href="#62">62</a>  <em> *   MUST NOT be sent.</em>
<a name="63" href="#63">63</a>  <em> *  &lt;/p></em>
<a name="64" href="#64">64</a>  <em> * </em>
<a name="65" href="#65">65</a>  <em> * @author &lt;a href="<a href="mailto:oleg@ural.ru" target="alexandria_uri">mailto:oleg@ural.ru</a>">Oleg Kalnichevski&lt;/a></em>
<a name="66" href="#66">66</a>  <em> * </em>
<a name="67" href="#67">67</a>  <em> * @version $Revision$ $Date$</em>
<a name="68" href="#68">68</a>  <em> *</em>
<a name="69" href="#69">69</a>  <em> * @since 3.0</em>
<a name="70" href="#70">70</a>  <em> */</em>
<a name="71" href="#71">71</a>  <strong>public</strong> <strong>class</strong> <a href="../../../../org/apache/commons/httpclient/HttpVersion.html">HttpVersion</a> implements Comparable {
<a name="72" href="#72">72</a>  
<a name="73" href="#73">73</a>      <em>/**<em>* Major version number of the HTTP protocol */</em></em>
<a name="74" href="#74">74</a>      <strong>private</strong> <strong>int</strong> major = 0;
<a name="75" href="#75">75</a>  
<a name="76" href="#76">76</a>      <em>/**<em>* Minor version number of the HTTP protocol */</em></em>
<a name="77" href="#77">77</a>      <strong>private</strong> <strong>int</strong> minor = 0;
<a name="78" href="#78">78</a>  
<a name="79" href="#79">79</a>      <em>/**<em>* HTTP protocol version 0.9 */</em></em>
<a name="80" href="#80">80</a>      <strong>public</strong> <strong>static</strong> <strong>final</strong> <a href="../../../../org/apache/commons/httpclient/HttpVersion.html">HttpVersion</a> HTTP_0_9 = <strong>new</strong> <a href="../../../../org/apache/commons/httpclient/HttpVersion.html">HttpVersion</a>(0, 9);  
<a name="81" href="#81">81</a>  
<a name="82" href="#82">82</a>      <em>/**<em>* HTTP protocol version 1.0 */</em></em>
<a name="83" href="#83">83</a>      <strong>public</strong> <strong>static</strong> <strong>final</strong> <a href="../../../../org/apache/commons/httpclient/HttpVersion.html">HttpVersion</a> HTTP_1_0 = <strong>new</strong> <a href="../../../../org/apache/commons/httpclient/HttpVersion.html">HttpVersion</a>(1, 0);  
<a name="84" href="#84">84</a>  
<a name="85" href="#85">85</a>      <em>/**<em>* HTTP protocol version 1.1 */</em></em>
<a name="86" href="#86">86</a>      <strong>public</strong> <strong>static</strong> <strong>final</strong> <a href="../../../../org/apache/commons/httpclient/HttpVersion.html">HttpVersion</a> HTTP_1_1 = <strong>new</strong> <a href="../../../../org/apache/commons/httpclient/HttpVersion.html">HttpVersion</a>(1, 1);  
<a name="87" href="#87">87</a>      
<a name="88" href="#88">88</a>      <em>/**<em>*</em></em>
<a name="89" href="#89">89</a>  <em>     * Create an HTTP protocol version designator.</em>
<a name="90" href="#90">90</a>  <em>     *</em>
<a name="91" href="#91">91</a>  <em>     * @param major   the major version number of the HTTP protocol</em>
<a name="92" href="#92">92</a>  <em>     * @param minor   the minor version number of the HTTP protocol</em>
<a name="93" href="#93">93</a>  <em>     * </em>
<a name="94" href="#94">94</a>  <em>     * @throws IllegalArgumentException if either major or minor version number is negative</em>
<a name="95" href="#95">95</a>  <em>     */</em>
<a name="96" href="#96">96</a>      <strong>public</strong> <a href="../../../../org/apache/commons/httpclient/HttpVersion.html">HttpVersion</a>(<strong>int</strong> major, <strong>int</strong> minor) {
<a name="97" href="#97">97</a>          <strong>if</strong> (major &lt; 0) {
<a name="98" href="#98">98</a>              <strong>throw</strong> <strong>new</strong> IllegalArgumentException(<span class="string">"HTTP major version number may not be negative"</span>);
<a name="99" href="#99">99</a>          }
<a name="100" href="#100">100</a>         <strong>this</strong>.major = major;
<a name="101" href="#101">101</a>         <strong>if</strong> (minor &lt; 0) {
<a name="102" href="#102">102</a>             <strong>throw</strong> <strong>new</strong> IllegalArgumentException(<span class="string">"HTTP minor version number may not be negative"</span>);
<a name="103" href="#103">103</a>         }
<a name="104" href="#104">104</a>         <strong>this</strong>.minor = minor;
<a name="105" href="#105">105</a>     }
<a name="106" href="#106">106</a>     
<a name="107" href="#107">107</a>     <em>/**<em>*</em></em>
<a name="108" href="#108">108</a> <em>     * Returns the major version number of the HTTP protocol.</em>
<a name="109" href="#109">109</a> <em>     * </em>
<a name="110" href="#110">110</a> <em>     * @return the major version number.</em>
<a name="111" href="#111">111</a> <em>     */</em>
<a name="112" href="#112">112</a>     <strong>public</strong> <strong>int</strong> getMajor() {
<a name="113" href="#113">113</a>         <strong>return</strong> major;
<a name="114" href="#114">114</a>     }
<a name="115" href="#115">115</a> 
<a name="116" href="#116">116</a>     <em>/**<em>*</em></em>
<a name="117" href="#117">117</a> <em>     * Returns the minor version number of the HTTP protocol.</em>
<a name="118" href="#118">118</a> <em>     * </em>
<a name="119" href="#119">119</a> <em>     * @return the minor version number.</em>
<a name="120" href="#120">120</a> <em>     */</em>
<a name="121" href="#121">121</a>     <strong>public</strong> <strong>int</strong> getMinor() {
<a name="122" href="#122">122</a>         <strong>return</strong> minor;
<a name="123" href="#123">123</a>     }
<a name="124" href="#124">124</a> 
<a name="125" href="#125">125</a>     <em>/**<em>*</em></em>
<a name="126" href="#126">126</a> <em>     * @see java.lang.Object#hashCode()</em>
<a name="127" href="#127">127</a> <em>     */</em>
<a name="128" href="#128">128</a>     <strong>public</strong> <strong>int</strong> hashCode() {
<a name="129" href="#129">129</a>         <strong>return</strong> <strong>this</strong>.major * 100000 + <strong>this</strong>.minor;
<a name="130" href="#130">130</a>     }
<a name="131" href="#131">131</a>         
<a name="132" href="#132">132</a>     <em>/**<em>*</em></em>
<a name="133" href="#133">133</a> <em>     * @see java.lang.Object#equals(java.lang.Object)</em>
<a name="134" href="#134">134</a> <em>     */</em>
<a name="135" href="#135">135</a>     <strong>public</strong> <strong>boolean</strong> equals(Object obj) {
<a name="136" href="#136">136</a>         <strong>if</strong> (<strong>this</strong> == obj) {
<a name="137" href="#137">137</a>             <strong>return</strong> <strong>true</strong>;
<a name="138" href="#138">138</a>         }
<a name="139" href="#139">139</a>         <strong>if</strong> (!(obj instanceof HttpVersion)) {
<a name="140" href="#140">140</a>             <strong>return</strong> false;
<a name="141" href="#141">141</a>         }
<a name="142" href="#142">142</a>         <strong>return</strong> equals((HttpVersion)obj);  
<a name="143" href="#143">143</a>     }
<a name="144" href="#144">144</a> 
<a name="145" href="#145">145</a>     <em>/**<em>*</em></em>
<a name="146" href="#146">146</a> <em>     * Compares this HTTP protocol version with another one.</em>
<a name="147" href="#147">147</a> <em>     * </em>
<a name="148" href="#148">148</a> <em>     * @param anotherVer the version to be compared with.</em>
<a name="149" href="#149">149</a> <em>     *  </em>
<a name="150" href="#150">150</a> <em>     * @return a negative integer, zero, or a positive integer as this version is less than, </em>
<a name="151" href="#151">151</a> <em>     *    equal to, or greater than the specified version.     </em>
<a name="152" href="#152">152</a> <em>     */</em>
<a name="153" href="#153">153</a>     <strong>public</strong> <strong>int</strong> compareTo(<a href="../../../../org/apache/commons/httpclient/HttpVersion.html">HttpVersion</a> anotherVer) {
<a name="154" href="#154">154</a>         <strong>if</strong> (anotherVer == <strong>null</strong>) {
<a name="155" href="#155">155</a>             <strong>throw</strong> <strong>new</strong> IllegalArgumentException(<span class="string">"Version parameter may not be null"</span>); 
<a name="156" href="#156">156</a>         }
<a name="157" href="#157">157</a>         <strong>int</strong> delta = getMajor() - anotherVer.getMajor();
<a name="158" href="#158">158</a>         <strong>if</strong> (delta == 0) {
<a name="159" href="#159">159</a>             delta = getMinor() - anotherVer.getMinor();
<a name="160" href="#160">160</a>         }
<a name="161" href="#161">161</a>         <strong>return</strong> delta;
<a name="162" href="#162">162</a>     }
<a name="163" href="#163">163</a> 
<a name="164" href="#164">164</a>     <em>/**<em>*</em></em>
<a name="165" href="#165">165</a> <em>     * @see java.lang.Comparable#compareTo(java.lang.Object)</em>
<a name="166" href="#166">166</a> <em>     */</em>
<a name="167" href="#167">167</a>     <strong>public</strong> <strong>int</strong> compareTo(Object o) {
<a name="168" href="#168">168</a>         <strong>return</strong> compareTo((HttpVersion)o);
<a name="169" href="#169">169</a>     }
<a name="170" href="#170">170</a> 
<a name="171" href="#171">171</a>     <em>/**<em>*</em></em>
<a name="172" href="#172">172</a> <em>     * Test if the HTTP protocol version is equal to the given number.</em>
<a name="173" href="#173">173</a> <em>     * </em>
<a name="174" href="#174">174</a> <em>     * @return &lt;tt>true&lt;/tt> if HTTP protocol version is given to the given number, </em>
<a name="175" href="#175">175</a> <em>     *         &lt;tt>false&lt;/tt> otherwise.</em>
<a name="176" href="#176">176</a> <em>     */</em>
<a name="177" href="#177">177</a>     <strong>public</strong> <strong>boolean</strong> equals(<a href="../../../../org/apache/commons/httpclient/HttpVersion.html">HttpVersion</a> version) {
<a name="178" href="#178">178</a>         <strong>return</strong> compareTo(version) == 0;  
<a name="179" href="#179">179</a>     }
<a name="180" href="#180">180</a> 
<a name="181" href="#181">181</a>     <em>/**<em>*</em></em>
<a name="182" href="#182">182</a> <em>     * Test if the HTTP protocol version is greater or equal to the given number.</em>
<a name="183" href="#183">183</a> <em>     * </em>
<a name="184" href="#184">184</a> <em>     * @return &lt;tt>true&lt;/tt> if HTTP protocol version is greater or equal given to the </em>
<a name="185" href="#185">185</a> <em>     *         given number, &lt;tt>false&lt;/tt> otherwise.</em>
<a name="186" href="#186">186</a> <em>     */</em>
<a name="187" href="#187">187</a>     <strong>public</strong> <strong>boolean</strong> greaterEquals(<a href="../../../../org/apache/commons/httpclient/HttpVersion.html">HttpVersion</a> version) {
<a name="188" href="#188">188</a>         <strong>return</strong> compareTo(version) >= 0;
<a name="189" href="#189">189</a>     }
<a name="190" href="#190">190</a> 
<a name="191" href="#191">191</a>     <em>/**<em>*</em></em>
<a name="192" href="#192">192</a> <em>     * Test if the HTTP protocol version is less or equal to the given number.</em>
<a name="193" href="#193">193</a> <em>     * </em>
<a name="194" href="#194">194</a> <em>     * @return &lt;tt>true&lt;/tt> if HTTP protocol version is less or equal to given to the </em>
<a name="195" href="#195">195</a> <em>     *         given number, &lt;tt>false&lt;/tt> otherwise.</em>
<a name="196" href="#196">196</a> <em>     */</em>
<a name="197" href="#197">197</a>     <strong>public</strong> <strong>boolean</strong> lessEquals(<a href="../../../../org/apache/commons/httpclient/HttpVersion.html">HttpVersion</a> version) {
<a name="198" href="#198">198</a>         <strong>return</strong> compareTo(version) &lt;= 0;
<a name="199" href="#199">199</a>     }
<a name="200" href="#200">200</a> 
<a name="201" href="#201">201</a>     <em>/**<em>*</em></em>
<a name="202" href="#202">202</a> <em>     * @see java.lang.Object#toString()</em>
<a name="203" href="#203">203</a> <em>     */</em>
<a name="204" href="#204">204</a>     <strong>public</strong> String toString() {
<a name="205" href="#205">205</a>         StringBuffer buffer = <strong>new</strong> StringBuffer();
<a name="206" href="#206">206</a>         buffer.append(<span class="string">"HTTP/"</span>); 
<a name="207" href="#207">207</a>         buffer.append(<strong>this</strong>.major); 
<a name="208" href="#208">208</a>         buffer.append('.'); 
<a name="209" href="#209">209</a>         buffer.append(<strong>this</strong>.minor); 
<a name="210" href="#210">210</a>         <strong>return</strong> buffer.toString();
<a name="211" href="#211">211</a>     }
<a name="212" href="#212">212</a> 
<a name="213" href="#213">213</a>     <em>/**<em>*</em></em>
<a name="214" href="#214">214</a> <em>     * Parses the textual representation of the given HTTP protocol version.</em>
<a name="215" href="#215">215</a> <em>     * </em>
<a name="216" href="#216">216</a> <em>     * @return HTTP protocol version.</em>
<a name="217" href="#217">217</a> <em>     * </em>
<a name="218" href="#218">218</a> <em>     * @throws ProtocolException if the string is not a valid HTTP protocol version. </em>
<a name="219" href="#219">219</a> <em>     */</em>
<a name="220" href="#220">220</a>     <strong>public</strong> <strong>static</strong> <a href="../../../../org/apache/commons/httpclient/HttpVersion.html">HttpVersion</a> parse(<strong>final</strong> String s) throws ProtocolException {
<a name="221" href="#221">221</a>         <strong>if</strong> (s == <strong>null</strong>) {
<a name="222" href="#222">222</a>             <strong>throw</strong> <strong>new</strong> IllegalArgumentException(<span class="string">"String may not be null"</span>);
<a name="223" href="#223">223</a>         }
<a name="224" href="#224">224</a>         <strong>if</strong> (!s.startsWith(<span class="string">"HTTP/"</span>)) {
<a name="225" href="#225">225</a>             <strong>throw</strong> <strong>new</strong> <a href="../../../../org/apache/commons/httpclient/ProtocolException.html">ProtocolException</a>(<span class="string">"Invalid HTTP version string: "</span> + s);
<a name="226" href="#226">226</a>         }
<a name="227" href="#227">227</a>         <strong>int</strong> major, minor;
<a name="228" href="#228">228</a>         
<a name="229" href="#229">229</a>         <strong>int</strong> i1 = <span class="string">"HTTP/"</span>.length();
<a name="230" href="#230">230</a>         <strong>int</strong> i2 = s.indexOf(<span class="string">"."</span>, i1);
<a name="231" href="#231">231</a>         <strong>if</strong> (i2 == -1) {
<a name="232" href="#232">232</a>             <strong>throw</strong> <strong>new</strong> <a href="../../../../org/apache/commons/httpclient/ProtocolException.html">ProtocolException</a>(<span class="string">"Invalid HTTP version number: "</span> + s);
<a name="233" href="#233">233</a>         }
<a name="234" href="#234">234</a>         <strong>try</strong> {
<a name="235" href="#235">235</a>             major = Integer.parseInt(s.substring(i1, i2)); 
<a name="236" href="#236">236</a>         } <strong>catch</strong> (NumberFormatException e) {
<a name="237" href="#237">237</a>             <strong>throw</strong> <strong>new</strong> <a href="../../../../org/apache/commons/httpclient/ProtocolException.html">ProtocolException</a>(<span class="string">"Invalid HTTP major version number: "</span> + s);
<a name="238" href="#238">238</a>         }
<a name="239" href="#239">239</a>         i1 = i2 + 1;
<a name="240" href="#240">240</a>         i2 = s.length();
<a name="241" href="#241">241</a>         <strong>try</strong> {
<a name="242" href="#242">242</a>             minor = Integer.parseInt(s.substring(i1, i2)); 
<a name="243" href="#243">243</a>         } <strong>catch</strong> (NumberFormatException e) {
<a name="244" href="#244">244</a>             <strong>throw</strong> <strong>new</strong> <a href="../../../../org/apache/commons/httpclient/ProtocolException.html">ProtocolException</a>(<span class="string">"Invalid HTTP minor version number: "</span> + s);
<a name="245" href="#245">245</a>         }
<a name="246" href="#246">246</a>         <strong>return</strong> <strong>new</strong> <a href="../../../../org/apache/commons/httpclient/HttpVersion.html">HttpVersion</a>(major, minor);
<a name="247" href="#247">247</a>     }
<a name="248" href="#248">248</a> 
<a name="249" href="#249">249</a> }
</pre>
<hr/><div id="footer">This page was automatically generated by <a href="http://maven.apache.org/">Maven</a></div></body>
</html>

